/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: SimpleLocationTripleUnmarshaller.java,v 96a070c6a0a0 2010/06/23 23:07:19 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.observation.semantic;

import javax.annotation.Nonnull;
import java.util.ArrayList;
import java.util.List;
import it.tidalwave.util.As;
import it.tidalwave.util.NotFoundException;
import it.tidalwave.semantic.io.json.impl.DehydratedTriple;
import it.tidalwave.semantic.io.json.spi.TripleUnmarshallerSupport;
import it.tidalwave.bluebill.observation.simple.SimpleLocation;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class SimpleLocationTripleUnmarshaller extends TripleUnmarshallerSupport
  {
    @Override @Nonnull
    public As unmarshal (final @Nonnull List<DehydratedTriple> triples, final @Nonnull Context context)
      {
        // TODO: what about retrieving the observationSet and calling findOrCreate(?)
        final List<Object> capabilities = new ArrayList<Object>();
//        capabilities.add(new DefaultIdentifiable(triples.get(0).getSubject()));

        try
          {
            final String displayName = (String)findTripleWithPredicate(triples, Vocabulary.RDFS_LABEL).getObject();
//            capabilities.add(new DefaultDisplayable(displayName, "SimpleLocation"));
            return new SimpleLocation(displayName);
          }
        catch (NotFoundException e)
          {
            throw new RuntimeException(e);
            // ok. no Displayable
          }

//        return new SimpleLocation(capabilities.toArray());
      }
  }
