/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: SimpleObservationItemTripleMarshaller.java,v 7d281dd2e2f1 2010/06/25 00:00:16 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.observation.semantic;

import javax.annotation.Nonnull;
import java.util.List;
import it.tidalwave.util.As;
import it.tidalwave.semantic.io.json.Triple;
import it.tidalwave.semantic.io.json.spi.impl.AsTripleMarshaller;
import it.tidalwave.bluebill.observation.Cardinality;
import it.tidalwave.bluebill.observation.ObservationItem;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class SimpleObservationItemTripleMarshaller extends AsTripleMarshaller
  {
    @Override @Nonnull
    public List<Triple> marshal (final @Nonnull As entity)
      {
        final List<Triple> triples = super.marshal(entity);
        final ObservationItem observationItem = (ObservationItem)entity;
        triples.add(new Triple(observationItem, Vocabulary.RDF_ABOUT, Vocabulary.OBSERVATION_ITEM));
        triples.add(new Triple(observationItem, Vocabulary.DC_SUBJECT, observationItem.getObservable()));

        final Cardinality cardinality = observationItem.getCardinality();

        if (!cardinality.equals(Cardinality.UNDEFINED))
          {
            triples.add(new Triple(observationItem, Vocabulary.CARDINALITY, cardinality));
          }

        return triples;
      }
  }
