/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: SimpleObservationItemTripleUnmarshaller.java,v 7d281dd2e2f1 2010/06/25 00:00:16 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.observation.semantic;

import javax.annotation.Nonnull;
import java.util.List;
import it.tidalwave.util.As;
import it.tidalwave.util.NotFoundException;
import it.tidalwave.semantic.io.json.impl.DehydratedTriple;
import it.tidalwave.semantic.io.json.spi.TripleUnmarshallerSupport;
import it.tidalwave.bluebill.observation.Cardinality;
import it.tidalwave.bluebill.observation.Observable;
import it.tidalwave.bluebill.observation.simple.SimpleObservation;
import it.tidalwave.bluebill.observation.simple.SimpleObservationItem;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class SimpleObservationItemTripleUnmarshaller extends TripleUnmarshallerSupport
  {
    @Override @Nonnull
    public As unmarshal (final @Nonnull List<DehydratedTriple> triples, final @Nonnull Context context)
      {
        try
          {
            final SimpleObservation observation = (SimpleObservation)context.peek();
            final Observable observable = (Observable)context.find(findTripleWithPredicate(triples, Vocabulary.DC_SUBJECT).getObject());
            Cardinality cardinality = Cardinality.UNDEFINED; // FIXME
            return new SimpleObservationItem(observation, observable, cardinality);
          }
        catch (NotFoundException e)
          {
            throw new RuntimeException(e); // FIXME: throw a checked exception
          }
      }
  }
