/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: Vocabulary.java,v e82a4eeab3f8 2010/06/24 17:43:51 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.observation.semantic;

import it.tidalwave.util.Id;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public final class Vocabulary
  {
    public static final String OBS          = "http://www.tidalwave.it/rdf/observation/2010/06/22#";
    public static final String SKOS         = "http://www.w3.org/2004/02/skos/core#";
    public static final String DC           = "http://purl.org/dc/elements/1.1/";

    public static final Id RDF_ABOUT        = new Id("http://www.w3.org/1999/02/22-rdf-syntax-ns#about");
    public static final Id RDFS_LABEL       = new Id("http://www.w3.org/2000/01/rdf-schema#label");
    
    public static final String OWL_THING    = "http://www.w3.org/2002/07/owl#Thing";

    public static final Id SKOS_NARROWER    = new Id(SKOS + "narrower");

    public static final Id DC_CREATOR       = new Id(DC + "creator");
    public static final Id DC_DATE          = new Id(DC + "date");
    public static final Id DC_PUBLISHER     = new Id(DC + "publisher");
    public static final Id DC_SUBJECT       = new Id(DC + "subject");
    public static final Id DC_IDENTIFIER    = new Id(DC + "identifier");
    public static final Id DC_TYPE          = new Id(DC + "type");

    public static final Id OBSERVATION_SET  = new Id(OBS + "ObservationSet");
    public static final Id OBSERVATION      = new Id(OBS + "Observation");
    public static final Id OBSERVATION_ITEM = new Id(OBS + "ObservationItem");
    public static final Id OBSERVER         = new Id(OBS + "Observer");
    public static final Id OBSERVABLE       = new Id(OBS + "Observable");
    public static final Id LOCATION         = new Id(OBS + "Location");
    
    public static final Id CARDINALITY      = new Id(OBS + "hasCardinality");
    public static final Id MADE_AT          = new Id(OBS + "madeAt");
  }
