/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: MediaTripleMarshaller.java,v e82a4eeab3f8 2010/06/24 17:43:51 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.othermarshallers;

import javax.annotation.Nonnull;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import it.tidalwave.util.As;
import it.tidalwave.util.Id;
import it.tidalwave.util.Key;
import it.tidalwave.util.NotFoundException;
import it.tidalwave.semantic.io.json.Triple;
import it.tidalwave.bluebill.observation.semantic.Vocabulary;
import it.tidalwave.mobile.media.Media;
import it.tidalwave.semantic.io.json.spi.impl.AsTripleMarshaller;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class MediaTripleMarshaller extends AsTripleMarshaller
  {
    @Override @Nonnull
    public List<Triple> marshal (final @Nonnull As entity)
      {
        try
          {
            final List<Triple> triples = super.marshal(entity);
            final Media media = (Media)entity;
            final Set<Key<?>> keys = new HashSet<Key<?>>(media.getKeys());
            keys.remove(Media.ID);

//            triples.add(new Triple(media, Vocabulary.RDF_ABOUT, Media.MEDIA));

            for (final Key<?> key : keys)
              {
                if (!key.equals(Media.MIME_TYPE) && !key.equals(Media.DURATION))
                  {
                    triples.add(new Triple(media, new Id(key.stringValue()), media.get(key)));
                  }
              }

            return triples;
          }
        catch (NotFoundException e)
          {
            throw new RuntimeException(e);
          }
      }
  }
